-- DuraRecolor
-- Coded by Lilcure of Guild Shadowed Soul, Ysera US
-- Inspired by Qynova
-- Coding sampled from Fubar_DuraTek Coded by Tekkub are marked --| Tekkub begin and --| Tekkub end

		-- A rather simple addon, it does 3 things
		--	1. Changes the color of a UI frame based on durability
		--	2. Makes that frame flash
		--	3. Toggles the default durability frame
		
		-- TODO
		--	1. Set this up as a Fubar plug-in
		--	2. Let user set % it flashes at
		--	3. Let user set % it changes colors
		
-- Begin Date 08/14/2007

-- Library declarations
local L = AceLibrary("AceLocale-2.2"):new("DuraRecolor")
local gratuity = AceLibrary("Gratuity-2.0")
local crayon = AceLibrary("Crayon-2.0")
local abacus = AceLibrary("Abacus-2.0")

-- Global variables to this addon, hate to use them but it's the easiest way to handle this
local flashing = false;
local flashing_counter = 1; -- holds what step of the flash event we are on
local flashing_interval = 4; -- defines how often we flash
local flash_event = { .6,.3,.1,.3,.6,1,.6,.3,.1,.3,.6,1, }


--| Tekkub begin
local findstr = string.gsub(DURABILITY_TEMPLATE, "%%[^%s]+", "(.+)")

local items = {
	{name = INVTYPE_HEAD, slot = "Head"},
	{name = INVTYPE_SHOULDER, slot = "Shoulder"},
	{name = INVTYPE_CHEST, slot = "Chest"},
	{name = INVTYPE_WAIST, slot = "Waist"},
	{name = INVTYPE_LEGS, slot = "Legs"},
	{name = INVTYPE_FEET, slot = "Feet"},
	{name = INVTYPE_WRIST, slot = "Wrist"},
	{name = INVTYPE_HAND, slot = "Hands"},
	{name = INVTYPE_WEAPONMAINHAND, slot = "MainHand"},
	{name = INVTYPE_WEAPONOFFHAND, slot = "SecondaryHand"},
	{name = INVTYPE_RANGED, slot = "Ranged"},
}
--| Tekkub end

-- Console options
local opts = { 
    type='group',
    args = {
        showUIFrame = {
            type = 'toggle',
            name = L["Show UI Frame"],
            desc = L["If set, the default UI frame will be displayed."],
            get = "IsShowUIFrame",
            set = "ToggleShowUIFrame"
        },
        flashFrame = {
            type = 'toggle',
            name = L["Flash Frame"],
            desc = L["If set, the frame that is being recolored will flash periodically."],
            get = "IsFlashFrame",
            set = "ToggleFlashFrame"
        },
    },
}

DuraRecolor = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
DuraRecolor:RegisterChatCommand(L["Slash-Commands"], opts)

DuraRecolor:RegisterDB("DuraRecolorDB", "DuraRecolorDBPC")
DuraRecolor:RegisterDefaults("profile", {
	showUIFrame = true,
	flashFrame = true,
} )

--| Tekkub begin
function DuraRecolor:OnEnable()
	self:RegisterBucketEvent({
		"PLAYER_UNGHOST",
		"PLAYER_DEAD",
		"PLAYER_REGEN_ENABLED",
		"UPDATE_INVENTORY_ALERTS",
		"MERCHANT_SHOW",
		"MERCHANT_CLOSED",
	}, 1, "UpdateData")
end
--| Tekkub end

function DuraRecolor:UpdateData()
	if self:IsShowUIFrame() then
		DurabilityFrame:Hide()
	else
		DurabilityFrame:Show()
	end
--| Tekkub begin
	local t1, t2, tcost, tnum = 0, 0, 0, 0
	for i in ipairs(items) do
		local v1, v2, cost = self:UpdateItem(i)
		t1 = t1 + v1;
		t2 = t2 + v2;
		tcost = tcost + cost;
	end
--| Tekkub end
	tpercent = t1/t2;
	if tpercent < .25 then
		MinimapBorder:SetVertexColor(1,0,0);
		flashing = true;
	elseif tpercent < .50 then
		MinimapBorder:SetVertexColor(1,1,0);
		flashing = true;
	else
		flashing = false;
		MinimapBorder:SetVertexColor(1,1,1);
	end
	if flashing == true and self:IsFlashFrame() then
		self:ScheduleRepeatingEvent("FlashFrame", self.TriggerFlashFrame, flashing_interval, self)
	end
end

--| Tekkub begin
function DuraRecolor:UpdateItem(index)
	local item = items[index]
	local id = GetInventorySlotInfo(item.slot .. "Slot")
	local hasItem, _, cost = gratuity:SetInventoryItem("player", id)

	local v1, v2
	if hasItem then _, _, v1, v2 = gratuity:Find(findstr) end
	v1, v2, cost = tonumber(v1) or 0, tonumber(v2) or 0, tonumber(cost) or 0
	item.percent, item.cost = (v2 == 0) and 1 or v1/v2, cost
	item.hasItem = hasItem
	return v1, v2, cost
end
--| Tekkub end

function DuraRecolor:TriggerFlashFrame()
	if flashing == false then
		self:CancelScheduledEvent("FlashFrame")
	else
		self:ScheduleRepeatingEvent("FlashEvent", self.FlashEvent, .1, self)
	end
end

function DuraRecolor:FlashEvent()
	MinimapBorder:SetAlpha(flash_event[flashing_counter])
	if flashing_counter ~= 11 then
		flashing_counter = flashing_counter + 1
	else
		flashing_counter = 1;
		self:CancelScheduledEvent("FlashEvent")
	end
end

function DuraRecolor:IsShowUIFrame()
    return self.db.profile.showUIFrame
end

function DuraRecolor:ToggleShowUIFrame()
    self.db.profile.showUIFrame = not self.db.profile.showUIFrame
end

function DuraRecolor:IsFlashFrame()
    return self.db.profile.flashFrame
end

function DuraRecolor:ToggleFlashFrame()
    self.db.profile.flashFrame = not self.db.profile.flashFrame
end
